--****************************************************************
-- Here's where the camera is.
-- Aren't I clever? (*no*)
--****************************************************************

camera = class:new()


function camera:init()
	self._x = 0
	self._y = 0
	self.scale_x = 1
	self.scale_y = 1
	self.rot = 0
end

function camera:place()
	love.graphics.push()
	love.graphics.rotate(-self.rot)
	love.graphics.scale(1/self.scale_x,1/self.scale_y)
	love.graphics.translate(-self._x,-self._y)
end

function camera:delete()
	love.graphics.pop()
end

function camera:rotate(amount)
	self.rot = self.rot + amount
end

function camera:scale(ax,ay)
	ax = ax or 1
	self.scale_x = self.scale_x * ax
	self.scale_y = self.scale_y * (ay or ax)
end

function camera:set_pos(x,y)
	if x then self:setX(x) end
	if y then self:setY(y) end
end

function camera:move(ax,ay)
	self._x = self._x + (ax or 0)
	self._y = self._y + (ay or 0)
end

function camera:set_scale(ax,ay)
	self.scale_x = ax or self.scale_x
	self.scale_y = ay or self.scale_y
end

function camera:setY(value)
	if self._bounds then
		self._y = math.clamp(value, self._bounds.y1, self._bounds.y2)
	else
		self._y = value
	end
end

function camera:setX(value)
	if self._bounds then
		self._x = math.clamp(value, self._bounds.x1, self._bounds.x2)
	else
		self._x = value
	end
end