player = class:new()

function player:init(x,y)

	self.x = x
	self.y = y
	self.w = 16
	self.h = 16
	self.xsp = 0
	self.ysp = 0
	self.frame = 17 -- animation anyone
	self.on_ground = false
	self.active = true
	self.xscale = 1
	self.dead = false
	self.grav = -300
	self.dir = "right"
	self.state = "falling"
	

	self.v = 0 -- whatever it wants to be
	self.jump = -200 -- something related to michael jackson
	
	-- Hardon Collider Init
	self.rect = collider:addRectangle(self.x, self.y, self.w, self.h)

	-- Let's make a couple values so that movement won't effect gamespeed any with .isDown shit
	self.movingLeft = false
	self.movingRight = false
end


function player:update(dt)
	self.oldx, self.oldy = self.x, self.y

	if self.movingLeft == true then
		self:left()
		self.dir = "left"
	elseif self.movingRight == true then
		self:right()
		self.dir = "right"
	else
		self.xsp = 0
	end
	
	self.v = self.v - self.grav * dt
	self.y = self.y + self.v * dt
	self.x = self.x + self.xsp
	self.rect:moveTo(self.x, self.y)

end


function player:draw()
	love.graphics.drawq(sprites[2],quads[self.frame],self.x,self.y,0,self.xscale,1)
	love.graphics.print("X, Y: "..self.x..","..self.y,5,5)
	self.rect:draw("line")
	love.graphics.setColor(255,0,0)
	love.graphics.rectangle("line", self.x, self.y, 16, 16)
	love.graphics.setColor(255,255,255)
end


function player:keypressed(key, unix)
	
	-- Keyboard input is always better to be handled from :keypressed
	if self.active == true then
		if key == "left" then
			self.movingLeft = true
		elseif key == "right" then
			self.movingRight = true
		elseif key == "f" then
			self.v = self.jump
		else 
			self.xsp = 0
		end
	end

end

function player:keyreleased(key, unix)
	-- movement!
	if self.active == true then
		if key == "left" then
			self.movingLeft = false
		elseif key == "right" then
			self.movingRight = false
		else 
			self.xsp = 0
		end
	end

end




--********************************************************
--MOVEMENT RELATED GARBAGE AND OTHER FUNCTIONS GO HERE
--********************************************************


function player:left()
	self.xsp = -1
end


function player:right()
	self.xsp = 1
end


function player:jump()


end

